from typing import List
from app.models import ContactPerson, Address, Dewar, Proposal, Shipment

contacts: List[ContactPerson] = [
    ContactPerson(id=1, firstname="Frodo", lastname="Baggins", phone_number="123-456-7890", email="frodo.baggins@lotr.com"),
    ContactPerson(id=1, firstname="Frodo", lastname="Baggins", phone_number="123-456-7890", email="frodo.baggins@lotr.com"),
    ContactPerson(id=2, firstname="Samwise", lastname="Gamgee", phone_number="987-654-3210", email="samwise.gamgee@lotr.com"),
    ContactPerson(id=3, firstname="Aragorn", lastname="Elessar", phone_number="123-333-4444", email="aragorn.elessar@lotr.com"),
    ContactPerson(id=4, firstname="Legolas", lastname="Greenleaf", phone_number="555-666-7777", email="legolas.greenleaf@lotr.com"),
    ContactPerson(id=5, firstname="Gimli", lastname="Son of Gloin", phone_number="888-999-0000", email="gimli.sonofgloin@lotr.com"),
    ContactPerson(id=6, firstname="Gandalf", lastname="The Grey", phone_number="222-333-4444", email="gandalf.thegrey@lotr.com"),
    ContactPerson(id=7, firstname="Boromir", lastname="Son of Denethor", phone_number="111-222-3333", email="boromir.sonofdenethor@lotr.com"),
    ContactPerson(id=8, firstname="Galadriel", lastname="Lady of Lothlórien", phone_number="444-555-6666", email="galadriel.lothlorien@lotr.com"),
    ContactPerson(id=9, firstname="Elrond", lastname="Half-elven", phone_number="777-888-9999", email="elrond.halfelven@lotr.com"),
    ContactPerson(id=10, firstname="Eowyn", lastname="Shieldmaiden of Rohan", phone_number="000-111-2222", email="eowyn.rohan@lotr.com"),
]

return_addresses: List[Address] = [
    Address(id=1, street='123 Hobbiton St', city='Shire', zipcode='12345', country='Middle Earth'),
    Address(id=2, street='456 Rohan Rd', city='Edoras', zipcode='67890', country='Middle Earth'),
    Address(id=3, street='789 Greenwood Dr', city='Mirkwood', zipcode='13579', country='Middle Earth'),
    Address(id=4, street='321 Gondor Ave', city='Minas Tirith', zipcode='24680', country='Middle Earth'),
    Address(id=5, street='654 Falgorn Pass', city='Rivendell', zipcode='11223', country='Middle Earth')
]

dewars: List[Dewar] = [
    Dewar(
        id='DEWAR001', dewar_name='Dewar One', tracking_number='TRACK123', number_of_pucks=7, number_of_samples=70,
        return_address=[return_addresses[0]], contact_person=[contacts[0]], status='Ready for Shipping',
        ready_date='2023-09-30', shipping_date='', arrival_date='', returning_date='', qrcode='QR123DEWAR001'
    ),
    Dewar(
        id='DEWAR002', dewar_name='Dewar Two', tracking_number='TRACK124', number_of_pucks=3, number_of_samples=33,
        return_address=[return_addresses[1]], contact_person=[contacts[1]], status='In Preparation',
        ready_date='', shipping_date='', arrival_date='', returning_date='', qrcode='QR123DEWAR002'
    ),
    Dewar(
        id='DEWAR003', dewar_name='Dewar Three', tracking_number='TRACK125', number_of_pucks=7, number_of_samples=72,
        return_address=[return_addresses[0]], contact_person=[contacts[2]], status='Not Shipped', ready_date='2024.01.01',
        shipping_date='', arrival_date='', returning_date='', qrcode='QR123DEWAR003'
    ),
    Dewar(
        id='DEWAR004', dewar_name='Dewar Four', tracking_number='', number_of_pucks=7, number_of_samples=70,
        return_address=[return_addresses[0]], contact_person=[contacts[2]], status='Delayed', ready_date='2024.01.01',
        shipping_date='2024.01.02', arrival_date='', returning_date='', qrcode='QR123DEWAR003'
    ),
    Dewar(
        id='DEWAR005', dewar_name='Dewar Five', tracking_number='', number_of_pucks=3, number_of_samples=30,
        return_address=[return_addresses[0]], contact_person=[contacts[2]], status='Returned', ready_date='2024.01.01',
        shipping_date='2024.01.02', arrival_date='2024.01.03', returning_date='2024.01.07', qrcode='QR123DEWAR003'
    ),
]

proposals: List[Proposal] = [
    Proposal(id=1, number="PROPOSAL-FRODO-001"),  # "The Quest for the Ring"
    Proposal(id=2, number="PROPOSAL-GANDALF-002"),  # "The Fellowship's Journey"
    Proposal(id=3, number="PROPOSAL-ARAGORN-003"),  # "Return of the King"
    Proposal(id=4, number="PROPOSAL-SAURON-004"),  # "The Dark Lord's Plot"
    Proposal(id=5, number="PROPOSAL-MORDOR-005"),  # "The Road to Mount Doom"
]

specific_dewar_ids1 = ['DEWAR003']
specific_dewar_ids2 = ['DEWAR001', 'DEWAR002']
specific_dewar_ids3 = ['DEWAR003', 'DEWAR004', 'DEWAR005']

specific_dewars1 = [dewar for dewar in dewars if dewar.id in specific_dewar_ids1]
specific_dewars2 = [dewar for dewar in dewars if dewar.id in specific_dewar_ids2]
specific_dewars3 = [dewar for dewar in dewars if dewar.id in specific_dewar_ids3]

shipments = [
    Shipment(
        shipment_id='SHIPMORDOR', shipment_date='2024-10-10', shipment_name='Shipment from Mordor',
        shipment_status='Delivered', contact_person=[contacts[1]], proposal_number=[proposals[1]],
        return_address=[return_addresses[0]], comments='Handle with care', dewars=specific_dewars1
    ),
    Shipment(
        shipment_id='SHIPMORDOR2', shipment_date='2024-10-24', shipment_name='Shipment from Mordor',
        shipment_status='In Transit', contact_person=[contacts[3]], proposal_number=[proposals[2]],
        return_address=[return_addresses[1]], comments='Contains the one ring', dewars=specific_dewars2
    ),
    Shipment(
        shipment_id='SHIPMORDOR3', shipment_date='2024-10-28', shipment_name='Shipment from Mordor',
        shipment_status='In Transit', contact_person=[contacts[4]], proposal_number=[proposals[3]],
        return_address=[return_addresses[0]], comments='Contains the one ring', dewars=specific_dewars3
    )
]